import java.io.*;
import java.util.*;

public class deathstar_ai {
	public static void main(String[] args) throws IOException {
		BufferedReader in = new BufferedReader(new FileReader("deathstar.in"));
		StringTokenizer st = new StringTokenizer(in.readLine());
		int n = Integer.parseInt(st.nextToken()), m = Integer.parseInt(st.nextToken());
		boolean[][] g = new boolean[n][n];
		int[][] z = new int[n][n];
		int[] zc = new int[n];
		char[] s = new char[n * n];
		in.read(s, 0, n * n);
		int p = 0, q = 4, x = 0;
		for (int i = 0; i < n; ++i) {
			for (int j = i + 1; j < n; ++j, ++q) {
				if (q == 4) {
					q = 0; x = s[p++];
					if ((x >= '0') && (x <= '9')) x -= '0'; else x -= 'A' - 10;
				}
				if ((x & (1 << (3 - q))) != 0) g[i][j] = true; else g[i][j] = false;
				g[j][i] = !g[i][j];
				if (g[i][j]) z[i][zc[i]++] = j; else z[j][zc[j]++] = i;
			}
		}
		in.close();

		long result = 0;
		if (n >= m) {
			long[][] C = new long[n + 1][m + 1];
			C[0][0] = 1;
			for (int i = 1; i <= n; ++i) {
				C[i][0] = 1;
				for (int j = 1; j <= m; ++j)
					C[i][j] = C[i - 1][j - 1] + C[i - 1][j];
			}
			final int Q = 20;
			int[][] e = new int[n][(n + Q - 1) / Q];
			byte[] d = new byte[1 << Q];
			for (int i = 0; i < 1 << Q; ++i) {
				if (i == 0) d[i] = 0;
				else d[i] = (byte)(d[i >> 1] + (i & 1));
			}
			for (int i = 0; i < n; ++i) {
				for (int j = 0, t = 0; j < n; j += Q, ++t) {
					for (int k = 0; (k < Q) && (j + k < n); ++k) {
						e[i][t] <<= 1;
						if (g[i][j + k]) ++e[i][t];
					}
				}
			}
	
			if (m == 3) {
				result = C[n][3];
				for (int i = 0; i < n; ++i) {
					result -= C[zc[i]][2];
				}
			} else if (m == 4) {
				result = C[n][4] * 3;
				int nn = (n + Q - 1) / Q;
				for (int i = 0; i < n; ++i) {
					result -= C[zc[i]][2] * (n - 3);
					for (int j = i + 1; j < n; ++j) {
						int t = 0;
						for (int k = 0; k < nn; ++k) t += d[e[i][k] & e[j][k]];
						result += C[t][2];
					}
				}
			} else if (m == 5) {
				result = C[n][5] * 12;
				int nn = (n + Q - 1) / Q;
				for (int i = 0; i < n; ++i) {
					result -= C[zc[i]][2] * C[n - 3][2] * 2;
					for (int j = i + 1; j < n; ++j) {
						int t = 0;
						for (int k = 0; k < nn; ++k) t += d[e[i][k] & e[j][k]];
						int a = zc[i], b = zc[j];
						if (g[i][j]) --a; else --b;
						result += t * (a * b - a - b - t + 2);
					}
				}
			}
		}

		PrintWriter out = new PrintWriter(new FileWriter("deathstar.out"));
		out.println(result);
		out.close();
	}
}
