#include <cstdio>
#include <cctype>
#include <ctime>
#include <iostream>

using namespace std;

typedef long long i64;

const int MAXN = 2000;

char s[MAXN * MAXN];
int z[MAXN][MAXN];
int zc[MAXN];
bool g[MAXN][MAXN];
i64 C[MAXN + 1][6];
int u[MAXN];

int main() {
	int t1 = clock();
	
	freopen("deathstar.in", "r", stdin);
	freopen("deathstar.out", "w", stdout);
	
	gets(s);
	int n, m; sscanf(s, "%d %d", &n, &m);
	gets(s);
	int p = 0, q = 4, x = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j, ++q) {
			if (q == 4) {
				q = 0; x = s[p++];
				if (isdigit(x)) x -= '0'; else x -= 'A' - 10;
			}
			if ((x & (1 << (3 - q))) != 0) g[i][j] = true; else g[i][j] = false;
			g[j][i] = !g[i][j];
			if (g[i][j]) z[i][zc[i]++] = j; else z[j][zc[j]++] = i;
		}
	}
	
	int t2 = clock();
	
	C[0][0] = 1;
	for (int i = 1; i <= n; ++i) {
		C[i][0] = 1;
		for (int j = 1; j <= m; ++j)
			C[i][j] = C[i - 1][j - 1] + C[i - 1][j];
	}
	
	i64 result = 0;
	if (m == 3) {
		result = C[n][3];
		for (int i = 0; i < n; ++i) {
			result -= C[zc[i]][2];
		}
	} else if (m == 4) {
		result = C[n][4] * 3;
		for (int i = 0; i < n; ++i) u[i] = -1;
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < zc[i]; ++j) u[z[i][j]] = i;
			result -= C[zc[i]][2] * (n - 3);
			for (int j = i + 1; j < n; ++j) {
				int t = 0;
				for (int k = 0; k < zc[j]; ++k)
					if (u[z[j][k]] == i) ++t;
				result += C[t][2];
			}
		}
	} else if (m == 5) {
		result = C[n][5] * 12;
		for (int i = 0; i < n; ++i) u[i] = -1;
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < zc[i]; ++j) u[z[i][j]] = i;
			result -= C[zc[i]][2] * C[n - 3][2] * 2;
			for (int j = i + 1; j < n; ++j) {
				int t = 0;
				for (int k = 0; k < zc[j]; ++k)
					if (u[z[j][k]] == i) ++t;
				int a = zc[i], b = zc[j];
				if (g[i][j]) --a; else --b;
				result += t * (a * b - a - b - t + 2);
			}
		}
	}
	printf("%I64d\n", result);
	
	int t3 = clock();
	cerr << "Reading: " << (t2 - t1) * 1000 / CLOCKS_PER_SEC << "  Processing: " << (t3 - t2) * 1000 / CLOCKS_PER_SEC << "  Total: " << (t3 - t1) * 1000 / CLOCKS_PER_SEC << endl;
	
	return 0;
}
