#include "testlib.h"

using namespace std;

string ending(int x)
{
    x %= 100;
    if (x / 10 == 1)
        return "th";
    if (x % 10 == 1)
        return "st";
    if (x % 10 == 2)
        return "nd";
    if (x % 10 == 3)
        return "rd";
    return "th";
}

int main(int argc, char * argv[])
{
	registerTestlibCmd(argc, argv);

	int m = 0;
	while (!ans.seekEof())
	{
		m++;
		string a = ans.readString();
		string o = ouf.readString();

		if (a != o)
		{
			quitf(_wa, "%d%s numbers differ - expected: '%s', found: '%s'", m, ending(m).c_str(), a.c_str(), o.c_str());
		}
	}

	quitf(_ok, "%d numbers", m);
}
