#include <algorithm>
#include <cstdio>
#include "random.h"

using namespace std;

int n, m;
int e[202400][3];
int p[102400];

void addcycle(int k)
{
	int n0 = rndInt(n) + 1;
	if (n0 > n) n0 = n;
	e[m][0] = n0;
	e[m][1] = ++n;
	m++;
	for(int i = 2; i < k; i++)
	{
		e[m][0] = n;
		e[m][1] = ++n;
		m++;
	}
	e[m][0] = n;
	e[m][1] = n0;
	m++;
}

void addchain(int k)
{
	int n0 = rndInt(n) + 1;
	if (n0 > n) n0 = n;
	e[m][0] = n0;
	e[m][1] = ++n;
	m++;
	for(int i = 1; i < k; i++)
	{
		e[m][0] = n;
		e[m][1] = ++n;
		m++;
	}
}

int main()
{
	freopen("14", "wt", stdout);

	initrand(141441);

	n = 1;
	m = 0;
	addcycle(3);
	while (n < 99995)
	{
		int k = rndInt(2) + 3;
		if (n < 20 || rndInt(2) == 0) addcycle(k);
		else addchain(k);
	}

	printf("%d %d\n", n, m);
	for(int i = 0; i < m; i++)
	{
		e[i][2] = rndInt(5) + 1;
		printf("%d %d %d\n", e[i][0], e[i][1], e[i][2]);
	}
	int k = 100000;
	printf("%d\n", k);
	for(int i = 0; i < k; i++)
	{
		if (rndInt(12) == 1)
		{
			printf("R %d %d\n", rndInt(12) + 1, rndInt(5) + 1);
		}
		else
		{
			printf("P %d %d\n", rndInt(12) + 1, rndInt(n) + 1);
		}
	}

	return 0;
}
