#include <algorithm>
#include <cstdio>
#include "random.h"

using namespace std;

int n, m;
int e[202400][3];
int p[102400];

void addcycle(int k)
{
	int n0 = n;
	e[m][0] = n0;
	e[m][1] = ++n;
	m++;
	for(int i = 2; i < k; i++)
	{
		e[m][0] = n;
		e[m][1] = ++n;
		m++;
	}
	e[m][0] = n;
	e[m][1] = n0;
	m++;
}

void addchain(int k)
{
	int n0 = rndInt(n) + 1;
	if (n0 > n) n0 = n;
	e[m][0] = n0;
	e[m][1] = ++n;
	m++;
	for(int i = 1; i < k; i++)
	{
		e[m][0] = n;
		e[m][1] = ++n;
		m++;
	}
}

int main()
{
	freopen("15", "wt", stdout);

	initrand(779878);

	n = 1;
	m = 0;
	addcycle(3);
	while (n < 99998)
	{
		int k = 3;
		addcycle(k);
	}

	printf("%d %d\n", n, m);
	for(int i = 0; i < m; i++)
	{
		e[i][2] = (i % 3 < 2) ? 1 : 5;
		printf("%d %d %d\n", e[i][0], e[i][1], e[i][2]);
	}
	int k = 100000;
	printf("%d\n", k);
	for(int i = 0; i < k; i++)
	{
		if (i % 12 < 4)
		{
			if (i % 12 == 3) printf("R %d %d\n", rndInt(m) + 1, rndInt(90015) + 1);
			else printf("R %d %d\n", (i / 12) * 3 + i % 12 + 1, (i % 12 < 2) ? 1021 : (2045 + rndInt(6)));
		}
		else
		{
			printf("P %d %d\n", rndInt(100) + 1, n - rndInt(100));
		}
	}

	return 0;
}
