#!/bin/bash

function mpost_make()
{
  pushd ../problems || exit 1
  for f in * ; do
    if [ -d $f ] ; then
      if [ -d $f/statement ] ; then
        pushd $f/statement
        if [ -e $f.mp ] ; then
          mpost $f.mp
        fi
        popd
      fi
    fi
  done
  popd
}

function doit()
{
  latex $1.tex || exit 1
  latex $1.tex || exit 1
  dvips -t a4 $1.dvi || exit 1
  dvipdfmx -p a4 $1 || exit 1
}

#svnversion .. > revision.temp | echo X > revision.temp
mpost_make
doit "140823.en" || exit 1
#doit "140823.ru" || exit 1
#rm revision.temp
#svnversion . ../problems/*/statement
rm *.aux
rm *.dvi
rm *.log
