#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define x first
#define y second
#define in(n) int (n) = nxt()

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef int itn;
typedef pair<int, int> PII;

int nxt() {
    int res;
    scanf("%d", &res);
    return res;
}

struct query {
    ll tm;
    int id;
    int fl;
};

const int M = 100000;

query Q[M];

ll st1[M + M];
ll st2[M + M];

queue <int> q[M];

int n;

ll get(ll * st, int l, int r) {
    ll res = LLONG_MAX;
    for (l += n, r += n; l <= r; l = (l + 1) >> 1, r = (r - 1) >> 1) {
        if (l & 1) {
            res = min(res, st[l]);
        }
        if (!(r & 1)) {
            res = min(res, st[r]);
        }
    }
    return res;
}

set <int> events;
ll A, B;

void change(int v) {
    events.erase(q[v].front());
    q[v].pop();
    assert(!q[v].empty());
    int p = q[v].front();
    if (p == -1) {
        st1[v + n] = LLONG_MAX;
        st2[v + n] = LLONG_MAX;
    } else {
        st1[v + n] = Q[p].tm - B * v;
        st2[v + n] = Q[p].tm + B * v;
    }
    for (v += n, v >>= 1; v; v >>= 1) {
        st1[v] = min(st1[v + v], st1[v + v + 1]);
        st2[v] = min(st2[v + v], st2[v + v + 1]);
    }
}

void solve(){
    n = nxt(); in(m);
    A = nxt(), B = nxt();

    for (int i = 0; i < m; ++i) {
        int tm = nxt();
        int f = nxt() - 1;
        Q[i] = query{tm, i, f};
        q[f].push(i);
        events.insert(i);
    }
     for (int i = 0; i < n; ++i) {
        q[i].push(-1);
    }
    for (int i = 0; i < n; ++i) {
        int v = q[i].front();
        if (v == -1) {
            st1[i + n] = LLONG_MAX;
        } else {
            st1[i + n] = Q[v].tm - B * i;
        }
    }
    for (int i = n - 1; i > 0; --i) {
        st1[i] = min(st1[i + i], st1[i + i + 1]);
    }

    for (int i = 0; i < n; ++i) {
        int v = q[i].front();
        if (v == -1) {
            st2[i + n] = LLONG_MAX;
        } else {
            st2[i + n] = Q[v].tm + B * i;
        }
    }
    for (int i = n - 1; i > 0; --i) {
        st2[i] = min(st2[i + i], st2[i + i + 1]);
    }

    int fl = 0;
    long long tm = 0;
    long long ans[m];
    while (!events.empty()) {
        int id = *events.begin();
        tm = max(tm, Q[id].tm);
        if (Q[id].fl == fl) {
            change(Q[id].fl);
            ans[id] = tm;
            continue;
        }
        if (Q[id].fl > fl) {
            int l = fl, r = Q[id].fl;
            while (l < r) {
                int mid = (l + r) / 2;
                if (get(st1, fl, mid) <= tm - fl * B) {
                    r = mid;
                } else {
                    l = mid + 1;
                }
            }
            tm += (l - fl) * B;
            int ID = q[l].front();
            ans[ID] = tm;
            change(l);
            fl = l;
            tm += A;
            continue;
        }

        if (Q[id].fl < fl) {
            int l = Q[id].fl, r = fl;
            while (l < r) {
                int mid = (l + r + 1) / 2;
                if (get(st2, mid, fl) <= tm + fl * B) {
                    l = mid;
                } else {
                    r = mid - 1;
                }
            }
            tm += (fl - l) * B;
            int ID = q[l].front();
            ans[ID] = tm;
            change(l);
            fl = l;
            tm += A;
            continue;
        }
    }
    for (int i = 0; i < m; ++i) {
        cout << ans[i] << "\n";
    }
}

itn main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL

    solve();

    return 0;
}
