#include <iostream>
#include <set>
#include <cmath>

using namespace std;

const int MAXN = 100 * 1000 + 5;
const long long INF = 1000ll * 1000 * 1000 * 1000 * 1000 * 1000 + 5;
int t[MAXN], f[MAXN], curf, pos, a, b, n, m;
long long ans[MAXN], wait, curt;
set< pair<int, int> > tst, fst;

int dist(int f0, int pos0, int f1, int pos1) {
    return abs((f1 - f0) * b + pos1 - pos0);
}

int getClosest(int fl, int pos, bool up) {
    if(up)
        return fst.lower_bound(make_pair((pos? fl + 1 : fl), 0))->second;
    set< pair<int, int> >::iterator it = fst.lower_bound(make_pair(fl + 1, 0));
    it--;
    return it->second;
}

void go(long long t, bool up) {
    int x = curf * b + pos + t * (up? 1 : -1);
    curf = x / b;
    pos = x % b;
}

void process(long long endt) {
    while(!tst.empty()) {
        if(wait) {
            long long tw = min((long long)wait, endt - curt);
            if(!tw)
                break;
            curt += tw;
            wait -= tw;
            continue;
        }
        int to = f[tst.begin()->second];
        long long tto = endt - curt;
        int cl = getClosest(curf, pos, ((to - curf) * b - pos) >= 0);
        long long tcl = dist(curf, pos, f[cl], 0);
        if(tcl <= tto) {
            curt += tcl;
            curf = f[cl];
            pos = 0;
            tst.erase(make_pair(t[cl], cl));
            fst.erase(make_pair(f[cl], cl));
            ans[cl] = curt;
            wait = a;
            continue;
        }
        go(tto, ((to - curf) * b - pos) >= 0);
        break;
    }
    if(wait) {
        long long tw = min((long long)wait, endt - curt);
        curt += tw;
        wait -= tw;
    }
    curt = endt;
}

void add(int q) {
    tst.insert(make_pair(t[q], q));
    fst.insert(make_pair(f[q], q));
}

int main() {
    ios_base::sync_with_stdio(false);
    cin >> n >> m >> a >> b;
    for(int i = 0; i < m; i++) {
        cin >> t[i] >> f[i];
        f[i]--;
    }
    for(int i = 0; i < m; i++) {
        process(t[i]);
        add(i);
    }
    process(INF);
    for(int i = 0; i < m; i++)
        cout << ans[i] << '\n';
    return 0;
}
