#include <cstdio>
#include <cstring>
#include <cctype>
#include <ctime>
#include <iostream>
#include <cassert>

using namespace std;

typedef long long i64;

//#define SHOW_TIME

const int MAXN = 2000;
const int Q = 20;

char s[MAXN * MAXN];
int z[MAXN][MAXN];
int zc[MAXN];
bool g[MAXN][MAXN];
i64 C[MAXN + 1][6];
int e[MAXN][MAXN];
char d[1 << Q];

int main() {
#ifdef SHOW_TIME
	int t1 = clock();
#endif

	freopen("deathstar.in", "r", stdin);
	freopen("deathstar.out", "w", stdout);
	
	gets(s);
	int n, m; sscanf(s, "%d %d", &n, &m);
	
	assert((1 <= n) && (n <= 1400) && (2 < m) && (m < 6));
	
	if (n < m) {
		printf("0\n");
		return 0;
	}
	gets(s);
	assert(strlen(s) * 4 >= n * (n - 1) / 2);
	int p = 0, q = 4, x = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j, ++q) {
			if (q == 4) {
				q = 0; x = s[p++];
				assert(((x >= '0') && (x <= '9')) || ((x >= 'A') && (x <= 'F')));
				if (isdigit(x)) x -= '0'; else x -= 'A' - 10;
			}
			if ((x & (1 << (3 - q))) != 0) g[i][j] = true; else g[i][j] = false;
			g[j][i] = !g[i][j];
			if (g[i][j]) z[i][zc[i]++] = j; else z[j][zc[j]++] = i;
		}
	}

#ifdef SHOW_TIME
	int t2 = clock();
#endif

	C[0][0] = 1;
	for (int i = 1; i <= n; ++i) {
		C[i][0] = 1;
		for (int j = 1; j <= m; ++j)
			C[i][j] = C[i - 1][j - 1] + C[i - 1][j];
	}
	for (int i = 0; i < 1 << Q; ++i) {
		if (i == 0) d[i] = 0;
		else d[i] = (char)(d[i >> 1] + (i & 1));
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 0, t = 0; j < n; j += Q, ++t) {
			for (int k = 0; (k < Q) && (j + k < n); ++k) {
				e[i][t] <<= 1;
				if (g[i][j + k]) ++e[i][t];
			}
		}
	}
	i64 result = 0;
	if (m == 3) {
		result = C[n][3];
		for (int i = 0; i < n; ++i) {
			result -= C[zc[i]][2];
		}
	} else if (m == 4) {
		result = C[n][4] * 3;
		int nn = (n + Q - 1) / Q;
		for (int i = 0; i < n; ++i) {
			result -= C[zc[i]][2] * (n - 3);
			for (int j = i + 1; j < n; ++j) {
				int t = 0;
				for (int k = 0; k < nn; ++k) t += d[e[i][k] & e[j][k]];
				result += C[t][2];
			}
		}
	} else if (m == 5) {
		result = C[n][5] * 12;
		int nn = (n + Q - 1) / Q;
		for (int i = 0; i < n; ++i) {
			result -= C[zc[i]][2] * C[n - 3][2] * 2;
			for (int j = i + 1; j < n; ++j) {
				int t = 0;
				for (int k = 0; k < nn; ++k) t += d[e[i][k] & e[j][k]];
				int a = zc[i], b = zc[j];
				if (g[i][j]) --a; else --b;
				result += t * (a * b - a - b - t + 2);
			}
		}
	}
	cout << result << endl;
//	printf("%I64d\n", result);

#ifdef SHOW_TIME
	int t3 = clock();
	cerr << "Reading: " << (t2 - t1) * 1000 / CLOCKS_PER_SEC << "  Processing: " << (t3 - t2) * 1000 / CLOCKS_PER_SEC << "  Total: " << (t3 - t1) * 1000 / CLOCKS_PER_SEC << endl;
#endif
	return 0;
}
