import java.io.*;
import java.util.*;

public class deathstar_ai_n5 {
	public static void main(String[] args) throws IOException {
		BufferedReader in = new BufferedReader(new FileReader("deathstar.in"));
		StringTokenizer st = new StringTokenizer(in.readLine());

		int n = Integer.parseInt(st.nextToken()), m = Integer.parseInt(st.nextToken());
		boolean[][] g = new boolean[n][n];
		int[][] z = new int[n][n];
		int[] zc = new int[n];
		String s = in.readLine();
		int p = 0, q = 4, x = 0;
		for (int i = 0; i < n; ++i) {
			for (int j = i + 1; j < n; ++j, ++q) {
				if (q == 4) {
					q = 0; x = s.charAt(p++);
					if (Character.isDigit(x)) x -= '0'; else x -= 'A' - 10;
				}
				if ((x & (1 << (3 - q))) != 0) g[i][j] = true; else g[i][j] = false;
				g[j][i] = !g[i][j];
				if (g[i][j]) z[i][zc[i]++] = j; else z[j][zc[j]++] = i;
			}
		}
		in.close();

		long result = 0;
		if (m == 3) {
			for (int a = 0; a < n; ++a) {
				for (int i = 0; i < zc[a]; ++i) {
					int b = z[a][i];
					if (b == a) continue;
					for (int j = 0; j < zc[b]; ++j) {
						int c = z[b][j];
						if ((c == a) || (c == b)) continue;
						if (g[c][a]) ++result;
					}
				}
			}
			result /= 3;
		} else if (m == 4) {
			for (int a = 0; a < n; ++a) {
				for (int i = 0; i < zc[a]; ++i) {
					int b = z[a][i];
					if (b == a) continue;
					for (int j = 0; j < zc[b]; ++j) {
						int c = z[b][j];
						if ((c == a) || (c == b)) continue;
						for (int k = 0; k < zc[c]; ++k) {
							int d = z[c][k];
							if ((d == a) || (d == b) || (d == c)) continue;
							if (g[d][a]) ++result;
						}
					}
				}
			}
			result /= 4;
		} else {
			for (int a = 0; a < n; ++a) {
				for (int i = 0; i < zc[a]; ++i) {
					int b = z[a][i];
					if (b == a) continue;
					for (int j = 0; j < zc[b]; ++j) {
						int c = z[b][j];
						if ((c == a) || (c == b)) continue;
						for (int k = 0; k < zc[c]; ++k) {
							int d = z[c][k];
							if ((d == a) || (d == b) || (d == c)) continue;
							for (int l = 0; l < zc[d]; ++l) {
								int e = z[d][l];
								if ((e == a) || (e == b) || (e == c) || (e == d)) continue;
								if (g[e][a]) ++result;
							}
						}
					}
				}
			}
			result /= 5;
		}

		PrintWriter out = new PrintWriter(new FileWriter("deathstar.out"));
		out.println(result);
		out.close();
	}
}
