#include <set>
#include <map>
#include <queue>
#include <deque>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;

#define f first
#define s second
#define pb push_back
#define mp make_pair
#define sz(a) ((int)a.size())
#define all(a) a.begin(), a.end()
#define ms(a, x) memset(a, x, sizeof a)
#define MAXN 200002

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<pii, int> tri;

const int N = 1<<17;
const int inf = 1<<30;

int n, m, A, B;
pair <int, int> a[MAXN];
vector < pair<int, int> > g[MAXN];
int u[MAXN];
int ok[MAXN];
int ans[MAXN];

int main() {
	#ifdef LOCAL
	freopen("a.in", "r", stdin);
	freopen("a.out", "w", stdout);
	#endif

	scanf("%d%d%d%d", &n, &m, &A, &B);
	for (int i = 0; i < m; ++i)
	{
		scanf("%d%d", &a[i].f, &a[i].s);
		--a[i].s;
		g[a[i].s].pb(mp(a[i].f, i));
	}

	int curfloor = 0, curtime = 0;
	for (int i = 0; i < m; ++i)
	{
		if (ok[i]) continue;
		int nextfloor = a[i].s;
		curtime = max(curtime, a[i].f);
		while (curfloor != nextfloor)
		{
			if (u[curfloor] < sz(g[curfloor]) && g[curfloor][u[curfloor]].f <= curtime)
			{
				while(u[curfloor] < sz(g[curfloor]) && g[curfloor][u[curfloor]].f <= curtime) {
					ans[g[curfloor][u[curfloor]].s] = curtime;
					curtime += A;
					ok[g[curfloor][u[curfloor]].s] = 1;
					u[curfloor]++;
				}
				/*while(u[curfloor] < sz(g[curfloor]) && g[curfloor][u[curfloor]].f <= curtime) {
					ans[g[curfloor][u[curfloor]].s] = g[curfloor][u[curfloor]].f;
					curtime = g[curfloor][u[curfloor]].f + A;
					ok[g[curfloor][u[curfloor]].s] = 1;
					u[curfloor]++;
				}*/
			}
			if (curfloor < nextfloor)
				++curfloor;
			else
				--curfloor;
			curtime += B;
		}
		while(u[curfloor] < sz(g[curfloor]) && g[curfloor][u[curfloor]].f <= curtime) {
			ans[g[curfloor][u[curfloor]].s] = curtime;
			curtime += A;
			ok[g[curfloor][u[curfloor]].s] = 1;
			u[curfloor]++;
		}
		/*curtime += A;
		while(u[curfloor] < sz(g[curfloor]) && g[curfloor][u[curfloor]].f <= curtime) {
			ans[g[curfloor][u[curfloor]].s] = g[curfloor][u[curfloor]].f;
			curtime = g[curfloor][u[curfloor]].f + A;
			ok[g[curfloor][u[curfloor]].s] = 1;
			u[curfloor]++;
		}*/
	}

	for (int i = 0; i < m; ++i)
		printf("%d\n", ans[i]);

	return 0;
}
