#include <bits/stdc++.h>
using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define show(...)
	#define debug(...)
	#define deepen(...)
	#define timer(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)
#define ve vector
#define pa pair
#define tu tuple
#define mp make_pair
#define mt make_tuple
#define pb push_back
#define fs first
#define sc second
#define all(a) (a).begin(), (a).end()
#define sz(a) ((int)(a).size())

typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef unsigned char uc;
typedef pa<int, int> pii;
typedef pa<int, ll> pil;
typedef pa<ll, int> pli;
typedef pa<ll, ll> pll;
typedef ve<int> vi;

const ld pi = 3.1415926535897932384626433832795l;

template<typename T> inline auto sqr (T x) -> decltype(x * x) {return x * x;}
template<typename T> inline T abs (T x) {return x > T() ? x : -x;}
template<typename T1, typename T2> inline bool umx (T1& a, T2 b) {if (a < b) {a = b; return 1;} return 0;}
template<typename T1, typename T2> inline bool umn (T1& a, T2 b) {if (b < a) {a = b; return 1;} return 0;}

const int N = 1400;

struct Input {
	int n, m;
	bool a[N][N];
	
	bool read () {
		if (!(cin >> n >> m)) {
			return 0;
		}
		string s;
		getline(cin, s);
		getline(cin, s);
		vi q;
		ford (i, sz(s)) {
			int t = (s[i] >= '0' && s[i] <= '9') ? (s[i] - '0') : (10 + s[i] - 'A');
			forn (j, 4) {
				q.pb(t & 1);
				t >>= 1;
			}
		}
		reverse(all(q));
		int k = 0;
		memset(a, 0, sizeof a);
		forn (i, n) {
			for (int j = i + 1; j < n; ++j) {
				a[i][j] = q[k];
				a[j][i] = !q[k];
				++k;
			}
		}
		return 1;
	}

	void init (const Input &input) {
		*this = input;
	}
};

struct Data: Input {
	ll ans;
	
	void write () {
		cout << ans << endl;
	}
	
	virtual void solve () {}
	
	virtual void clear () {
		*this = Data();
	}
};

struct Solution: Data {
	static const int L = N / 64 + 1;
	static const int K = 10;
	
	ull aout[N][L], ain[N][L];
	int cnt2[N][N];
	
	static const int D = N / K + 1;

	int aout_[N][D];
	int sum[D][1 << K];
	
	void calc5 () {
		memset(aout_, 0, sizeof aout_);
		forn (i, n) {
			forn (j, n) {
				if (a[i][j]) {
					aout_[i][j / K] |= 1 << (j % K);
				}
			}
		}
		forn (i, n) {
			memset(sum, 0, sizeof sum);
			forn (j, n) {
				int k = j / K;
				int r = j % K;
				sum[k][1 << r] = cnt2[j][i];
			}
			forn (k, D) {
				for (int msk = 1; msk < (1 << K); ++msk) {
					int msk1 = msk & (msk - 1);
					sum[k][msk] = sum[k][msk1] + sum[k][msk - msk1];
				}
			}
			forn (j, n) {
				int tmp = 0;
				forn (k, D) {
					tmp += sum[k][aout_[j][k]];
				}
				ans += ll(tmp) * cnt2[i][j];
			}
		}
	}
	
	void solve () {
		memset(aout, 0, sizeof aout);
		memset(ain, 0, sizeof ain);
		forn (i, n) {
			forn (j, n) {
				if (a[i][j]) {
					aout[i][j >> 3] |= 1ull << (j & 7);
					ain[j][i >> 3] |= 1ull << (i & 7);
				}
			}
		}
		memset(cnt2, 0, sizeof cnt2);
		forn (i, n) {
			forn (j, n) {
				forn (k, L) {
					cnt2[i][j] += __builtin_popcountll(aout[i][k] & ain[j][k]);
				}
			}
		}
		if (m == 3) {
			forn (i, n) {
				forn (j, n) {
					ans += a[i][j] * cnt2[j][i];
				}
			}
		} else if (m == 4) {
			forn (i, n) {
				forn (j, n) {
					ans += cnt2[i][j] * cnt2[j][i];
				}
			}
		} else {
			calc5();
		}
		ans /= m;
	}
	
	void clear () {
		*this = Solution();
	}
};

Solution sol;

int main () {
	cout.setf(ios::showpoint | ios::fixed);
	cout.precision(20);
#ifdef SG
	freopen("a.in", "r", stdin);
//	freopen("output.txt", "w", stdout);
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}
#else
//	freopen("", "r", stdin);
//	freopen("", "w", stdout);
	sol.read();
	sol.solve();
	sol.write();
#endif

	return 0;
}
