#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define tm sdkjfldsf

const long long inf = (long long) 1e18 + 10;
const int size = 200 * 1000 + 100;

int n, m, a, b;
long long curtime = 0;
int curflr = 1;
int curevent = -1;
int tm[size];
int flr[size];

set <pair <int, int> > events;
set <pair <int, int> > activeevents;
set <int> activefloors;

set <pair <int, int> > activeonfloor[size];

long long ans[size];

void addevent(int num) {
	events.erase(mp(tm[num], num));
	activeevents.insert(mp(tm[num], num));

	activeonfloor[flr[num]].insert(mp(tm[num], num));
	if (activeonfloor[flr[num]].size() == 1u)
		activefloors.insert(flr[num]);
}

void removeevent(int num) {
	activeevents.erase(mp(tm[num], num));
	activeonfloor[flr[num]].erase(mp(tm[num], num));
	activefloors.erase(flr[num]);
				
	if (!activeonfloor[flr[num]].empty()) {
		activefloors.insert(flr[num]);
	}
}

int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));

	scanf("%d%d%d%d", &n, &m, &a, &b);
	for (int i = 0; i < m; i++) {
		scanf("%d%d", &tm[i], &flr[i]);

		events.insert(mp(tm[i], i));
	}

	while (!events.empty() || !activeevents.empty() || curevent != -1) {
		while (!events.empty() && events.begin()->fs <= curtime) {
			addevent(events.begin()->sc);
		}
		if (curevent == -1) {
			if (activeevents.empty()) {
				curtime = events.begin()->fs;
				addevent(events.begin()->sc);
				continue;
			} else {
				curevent = activeevents.begin()->sc;

				removeevent(curevent);

				continue;
			}
		}
		if (curflr == flr[curevent]) {
			ans[curevent] = curtime;
			curtime += a;
			curevent = -1;
			continue;
		}
		set <int>::iterator it = activefloors.lower_bound(curflr);
		if (it != activefloors.end() && *it == curflr) {
			ans[activeonfloor[curflr].begin()->sc] = curtime;
			removeevent(activeonfloor[curflr].begin()->sc);

			curtime += a;
			curtime += b;
			if (curflr < flr[curevent]) {
				curflr++;
			} else {
				curflr--;
			}
			continue;
			//while (
		}

		long long nrst;
		if (curflr < flr[curevent]) {
			set <int>::iterator it = activefloors.lower_bound(curflr);
			nrst = abs(flr[curevent] - curflr) * 1ll * b;
			if (!events.empty())
				nrst = min(nrst, events.begin()->fs - curtime); 
			if (it != activefloors.end()) {
				nrst = min(nrst, (*it - curflr) * 1ll * b); 
			}
		} else {
			set <int>::iterator it = activefloors.lower_bound(curflr);
			while (it != activefloors.begin() && (it == activefloors.end() || *it > curflr))
				--it;
			//if (*it < curflt) {
				nrst = abs(curflr - flr[curevent]) * 1ll * b;
			//}
			if (!events.empty())
				nrst = min(nrst, events.begin()->fs - curtime); 
			if (it != activefloors.end() && *it < curflr) {
				nrst = min(nrst, (curflr - *it) * 1ll * b); 
			}
		}

		long long steps = (nrst + b - 1) / b;
		if (curflr < flr[curevent])
			curflr += steps;
		else
			curflr -= steps;

		curtime += steps * b;
	}

	for (int i = 0; i < m; i++)
		printf("%lld\n", ans[i]);

	return 0;
}