#include <stdio.h>
#include <string.h>
#include <math.h>

#include <algorithm>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <vector>
#include <queue>
#include <deque>
#include <iostream>
#define Comanda pair<long long, int>
using namespace std;
int n, m, A, B, etaj[100100], etajnow, nrcom, etajcom, inter, ind;
long long sol[100100], timenow, timp[100100], arrive;
bool ocupat;
multiset <Comanda> S;
set <int> timpi[100100], indici[100100];
int aib[100100];

inline void Aduna(int poz, int val)
{
    while(poz <= n)
    {
        aib[poz] += val;
        poz += (poz & -poz);
    }
}

inline int Suma(int poz)
{
    int rez = 0;
    while(poz > 0)
    {
        rez += aib[poz];
        poz -= (poz & -poz);
    }
    return rez;
}

inline int CautareBinara1(int st, int dr)
{
    int mij, rez, sum;
    while(st <= dr)
    {
        mij = (st + dr) / 2;
        sum = Suma(mij) - Suma(st - 1);
        if(sum >= 1)
        {
            rez = mij;
            dr = mij - 1;
        }
        else
            st = mij + 1;
    }
    return rez;
}

inline int CautareBinara2(int st, int dr)
{
    int mij, rez, sum, total;
    total = Suma(dr) - Suma(st - 1);
    while(st <= dr)
    {
        mij = (st + dr) / 2;
        sum = Suma(mij) - Suma(st - 1);
        if(sum == total)
        {
            rez = mij;
            dr = mij - 1;
        }
        else
            st = mij + 1;
    }
    return rez;
}

int main ()
{
#ifdef local
    freopen ("b.in", "r", stdin);
    freopen ("", "w", stdout);
#endif
    int i, aux;
    cin >> n >> m >> A >> B;
    for(i = 1; i <= m; ++i)
    {
        cin >> timp[i] >> etaj[i];
        timpi[etaj[i]].insert(timp[i]);
        indici[etaj[i]].insert(i);
    }
    i = 1;
    ocupat = false;
    timenow = 0;
    etajnow = 1;
    while(i <= m || ocupat || nrcom > 0)
    {
        if(ocupat && etajnow == etajcom)
        {
            sol[ind] = timenow;
            ocupat = false;
            timenow += 1LL * A;
            continue;
        }
        while(i <= m && timp[i] <= timenow)
        {
            if(timp[i] == timenow && etaj[i] == etajnow)
            {
                sol[i] = timenow;
                timenow += 1LL * A;
                i++;
                continue;
            }
            S.insert(make_pair(timp[i], i));
            Aduna(etaj[i], 1);
            nrcom++;
            i++;
        }
        if(!ocupat)
        {
            if(nrcom == 0)
            {
                timenow = timp[i];
                if(timp[i] == timenow && etaj[i] == etajnow)
                {
                    sol[i] = timenow;
                    timenow += 1LL * A;
                    i++;
                    continue;
                }
                S.insert(make_pair(timp[i], i));
                nrcom++;
                aux = timenow;
                i++;
            }
            else
            {
                timenow = max(timenow, (*S.begin()).first);
                ind = (*S.begin()).second;
                ocupat = true;
                etajcom = etaj[(*S.begin()).second];
                Aduna(etajcom, -1);
                S.erase(S.find(*S.begin()));
                timpi[etajcom].erase(timpi[etajcom].begin());
                nrcom--;
            }
            continue;
        }
        arrive = timenow + 1LL * abs(etajnow - etajcom) * B;

        if(i <= m && arrive > timp[i])
        {
            inter = 0;
            if(etajnow < etajcom)
            {
                if(etajnow + 1 <= etajcom - 1 && Suma(etajcom - 1) - Suma(etajnow) > 0)
                    inter = CautareBinara1(etajnow + 1, etajcom - 1);
            }
            else
            {
                if(etajcom + 1 <= etajnow - 1 && Suma(etajnow - 1) - Suma(etajcom) > 0)
                    inter = CautareBinara2(etajcom + 1, etajnow - 1);
            }
            if(inter == 0)
            {
                S.insert(make_pair(timp[i], i));
                Aduna(etaj[i], 1);
                nrcom++;
                if(etajnow < etajcom)
                {
                    aux = etajnow;
                    if((timp[i] - timenow) % B != 0)
                        etajnow += (timp[i] - timenow) / B + 1;
                    else
                        etajnow += (timp[i] - timenow) / B;
                    timenow += 1LL * B * abs(aux - etajnow);
                }
                else
                {
                    aux = etajnow;
                    if((timp[i] - timenow) % B != 0)
                        etajnow -= (timp[i] - timenow) / B + 1;
                    else
                        etajnow -= (timp[i] - timenow) / B;
                    timenow += 1LL * B * abs(aux - etajnow);
                }
                i++;
            }
            else
            {
                arrive = timenow + 1LL * B * abs(etajnow - inter);
                if(arrive <= timp[i])
                {
                    timenow += 1LL * B * abs(etajnow - inter);
                    etajnow = inter;
                    S.erase(S.lower_bound(make_pair(*timpi[inter].begin(), 0)));
                    timpi[inter].erase(timpi[inter].begin());
                    sol[*indici[inter].begin()] = timenow;
                    indici[inter].erase(indici[inter].begin());
                    Aduna(inter, -1);
                    nrcom--;
                    timenow += 1LL * A;

                }
                else
                {
                    S.insert(make_pair(timp[i], i));
                    Aduna(etaj[i], 1);
                    nrcom++;
                    if(etajnow < etajcom)
                    {
                        aux = etajnow;
                        if((timp[i] - timenow) % B != 0)
                            etajnow += (timp[i] - timenow) / B + 1;
                        else
                            etajnow += (timp[i] - timenow) / B;
                        timenow += 1LL * B * abs(aux - etajnow);
                    }
                    else
                    {
                        aux = etajnow;
                        if((timp[i] - timenow) % B != 0)
                            etajnow -= (timp[i] - timenow) / B + 1;
                        else
                            etajnow -= (timp[i] - timenow) / B;
                        timenow += 1LL * B * abs(aux - etajnow);
                    }
                }
            }
            continue;
        }
        else
        {
            inter = 0;
            if(etajnow < etajcom)
            {
                if(etajnow + 1 <= etajcom - 1 && Suma(etajcom - 1) - Suma(etajnow) > 0)
                    inter = CautareBinara1(etajnow + 1, etajcom - 1);
            }
            else
            {
                if(etajcom + 1 <= etajnow - 1 && Suma(etajnow - 1) - Suma(etajcom) > 0)
                    inter = CautareBinara2(etajcom + 1, etajnow - 1);
            }
            if(inter == 0)
            {
                timenow += 1LL * B * abs(etajnow - etajcom);
                etajnow = etajcom;
                ocupat = false;
                sol[ind] = timenow;
                timenow += 1LL * A;
            }
            else
            {
                timenow += 1LL * B * abs(etajnow - inter);
                etajnow = inter;
                S.erase(S.lower_bound(make_pair(*timpi[inter].begin(), 0)));
                timpi[inter].erase(timpi[inter].begin());
                sol[*indici[inter].begin()] = timenow;
                indici[inter].erase(indici[inter].begin());
                nrcom--;
                Aduna(inter, -1);
                timenow += 1LL * A;
            }
            continue;
        }
    }
    for(i = 1; i <= m; ++i)
        cout << sol[i] << "\n";
    return 0;
}
