#include <stdio.h>
#include <string.h>
#include <math.h>

#include <algorithm>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <vector>
#include <queue>
#include <deque>
#include <iostream>
#include <ctime>
#define Comanda pair<long long, int>
using namespace std;
int n, m, A, B, etaj[100100], etajnow, nrcom, etajcom, inter, ind, ord[100100];
long long sol[100100], timenow, timp[100100], arrive;
bool ocupat;
multiset <Comanda> S;
multiset <int> timpi[100100], indici[100100];
int aib[100100];

void Aduna(int poz, int val)
{
    if(poz <= 0)
        poz = 1;
    while(poz <= n)
    {
        aib[poz] += val;
        poz += (poz & -poz);
    }
}

int Suma(int poz)
{
    int rez = 0;
    if(poz > n)
        poz = n;
    while(poz > 0)
    {
        rez += aib[poz];
        poz -= (poz & -poz);
    }
    return rez;
}

inline int CautareBinara1(int st, int dr)
{
    int mij, rez=0, sum;
    while(st <= dr)
    {
        mij = (st + dr) / 2;
        sum = Suma(mij) - Suma(st - 1);
        if(sum >= 1)
        {
            rez = mij;
            dr = mij - 1;
        }
        else
            st = mij + 1;
    }
    return rez;
}

inline int CautareBinara2(int st, int dr)
{
    int mij, rez=0, sum, total;
    total = Suma(dr) - Suma(st - 1);
    while(st <= dr)
    {
        mij = (st + dr) / 2;
        sum = Suma(mij) - Suma(st - 1);
        if(sum == total)
        {
            rez = mij;
            dr = mij - 1;
        }
        else
            st = mij + 1;
    }
    return rez;
}

inline bool Sortare(int i, int j)
{
    if(timp[i] == timp[j])
        return i < j;
    return timp[i] < timp[j];
}

int main ()
{
#ifdef local
    freopen ("b.in", "r", stdin);
    freopen ("", "w", stdout);
#endif
    clock_t start, stop;
    start = clock();
    int i, aux;
    cin >> n >> m >> A >> B;
    for(i = 1; i <= m; ++i)
        ord[i] = i;
    for(i = 1; i <= m; ++i)
    {
        cin >> timp[i] >> etaj[i];
        timpi[etaj[i]].insert(timp[i]);
    }
    sort(ord + 1, ord + m + 1, Sortare);
    for(i = 1; i <= m; ++i)
        indici[etaj[ord[i]]].insert(ord[i]);
    i = 1;
    ocupat = false;
    timenow = 0;
    etajnow = 1;
    while(i <= m || ocupat || nrcom > 0)
    {
        stop = clock();
        if(((double)stop - start) >= 1.5 * CLOCKS_PER_SEC)
            break;
        if(ocupat && etajnow == etajcom)
        {
            sol[ind] = timenow;
            ocupat = false;
            timenow += 1LL * A;
            continue;
        }
        if(Suma(etajnow) - Suma(etajnow - 1) > 0)
        {
            S.erase(S.lower_bound(make_pair(*timpi[etajnow].begin(), *indici[etajnow].begin())));
            timpi[etajnow].erase(timpi[etajnow].begin());
            sol[*indici[etajnow].begin()] = timenow;
            indici[etajnow].erase(indici[etajnow].begin());
            Aduna(etajnow, -1);
            nrcom--;
            timenow += 1LL * A;
            continue;
        }
        if(i <= m && timp[ord[i]] <= timenow)
        {
            if(etaj[ord[i]] == etajnow)
            {
                sol[ord[i]] = timenow;
                timenow += 1LL * A;
                i++;
                continue;
            }
            S.insert(make_pair(timp[ord[i]], ord[i]));
            Aduna(etaj[ord[i]], 1);
            nrcom++;
            i++;
            continue;
        }
        if(!ocupat)
        {
            if(nrcom == 0)
            {
                timenow = timp[ord[i]];
                if(etaj[ord[i]] == etajnow)
                {
                    sol[ord[i]] = timenow;
                    timenow += 1LL * A;
                    i++;
                    continue;
                }
                S.insert(make_pair(timp[ord[i]], ord[i]));
                nrcom++;
                aux = timenow;
                i++;
            }
            else
            {
                timenow = max(timenow, (*S.begin()).first);
                ind = (*S.begin()).second;
                ocupat = true;
                etajcom = etaj[(*S.begin()).second];
                Aduna(etajcom, -1);
                S.erase(S.find(*S.begin()));
                timpi[etajcom].erase(timpi[etajcom].begin());
                indici[etajcom].erase(indici[etajcom].begin());
                nrcom--;
            }
            continue;
        }
        arrive = timenow + 1LL * abs(etajnow - etajcom) * B;

        if(i <= m && arrive > timp[ord[i]])
        {
            inter = 0;
            if(etajnow < etajcom)
            {
                if(etajnow + 1 <= etajcom - 1 && Suma(etajcom - 1) - Suma(etajnow) > 0)
                    inter = CautareBinara1(etajnow + 1, etajcom - 1);
            }
            else
            {
                if(etajcom + 1 <= etajnow - 1 && Suma(etajnow - 1) - Suma(etajcom) > 0)
                    inter = CautareBinara2(etajcom + 1, etajnow - 1);
            }
            if(inter == 0)
            {
                S.insert(make_pair(timp[ord[i]], ord[i]));
                Aduna(etaj[ord[i]], 1);
                nrcom++;
                if(etajnow < etajcom)
                {
                    aux = etajnow;
                    if((timp[ord[i]] - timenow) % B != 0)
                        etajnow += (timp[ord[i]] - timenow) / B + 1;
                    else
                        etajnow += (timp[ord[i]] - timenow) / B;
                    timenow += 1LL * B * abs(aux - etajnow);
                }
                else
                {
                    aux = etajnow;
                    if((timp[ord[i]] - timenow) % B != 0)
                        etajnow -= (timp[ord[i]] - timenow) / B + 1;
                    else
                        etajnow -= (timp[ord[i]] - timenow) / B;
                    timenow += 1LL * B * abs(aux - etajnow);
                }
                i++;
            }
            else
            {
                arrive = timenow + 1LL * B * abs(etajnow - inter);
                if(arrive <= timp[ord[i]])
                {
                    timenow += 1LL * B * abs(etajnow - inter);
                    etajnow = inter;
                    S.erase(S.lower_bound(make_pair(*timpi[inter].begin(), *indici[inter].begin())));
                    timpi[inter].erase(timpi[inter].begin());
                    sol[*indici[inter].begin()] = timenow;
                    indici[inter].erase(indici[inter].begin());
                    Aduna(inter, -1);
                    nrcom--;
                    timenow += 1LL * A;

                }
                else
                {
                    S.insert(make_pair(timp[ord[i]], ord[i]));
                    Aduna(etaj[ord[i]], 1);
                    nrcom++;
                    if(etajnow < etajcom)
                    {
                        aux = etajnow;
                        if((timp[ord[i]] - timenow) % B != 0)
                            etajnow += (timp[ord[i]] - timenow) / B + 1;
                        else
                            etajnow += (timp[ord[i]] - timenow) / B;
                        timenow += 1LL * B * abs(aux - etajnow);
                    }
                    else
                    {
                        aux = etajnow;
                        if((timp[ord[i]] - timenow) % B != 0)
                            etajnow -= (timp[ord[i]] - timenow) / B + 1;
                        else
                            etajnow -= (timp[ord[i]] - timenow) / B;
                        timenow += 1LL * B * abs(aux - etajnow);
                    }
                }
            }
            continue;
        }
        else
        {
            inter = 0;
            if(etajnow < etajcom)
            {
                if(etajnow + 1 <= etajcom - 1 && Suma(etajcom - 1) - Suma(etajnow) > 0)
                    inter = CautareBinara1(etajnow + 1, etajcom - 1);
            }
            else
            {
                if(etajcom + 1 <= etajnow - 1 && Suma(etajnow - 1) - Suma(etajcom) > 0)
                    inter = CautareBinara2(etajcom + 1, etajnow - 1);
            }
            if(inter == 0)
            {
                timenow += 1LL * B * abs(etajnow - etajcom);
                etajnow = etajcom;
                ocupat = false;
                sol[ind] = timenow;
                timenow += 1LL * A;
            }
            else
            {
                timenow += 1LL * B * abs(etajnow - inter);
                etajnow = inter;
                S.erase(S.lower_bound(make_pair(*timpi[inter].begin(), *indici[inter].begin())));
                timpi[inter].erase(timpi[inter].begin());
                sol[*indici[inter].begin()] = timenow;
                indici[inter].erase(indici[inter].begin());
                nrcom--;
                Aduna(inter, -1);
                timenow += 1LL * A;
            }
            continue;
        }
    }
    for(i = 1; i <= m; ++i)
        cout << sol[i] << "\n";
    return 0;
}
